package com.hero.objects.powers;

import org.jdom.Element;

import com.hero.HeroDesigner;
import com.hero.objects.Adder;
import com.hero.objects.GenericObject;

/**
 * Copyright (c) 2000 - 2005, CompNet Design, Inc. All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, is prohibited unless the following conditions are met: 1.
 * Express written consent of CompNet Design, Inc. is obtained by the developer.
 * 2. Redistributions must retain this copyright notice. THIS SOFTWARE IS
 * PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * @author CompNet Design, Inc.
 * @version $Revision$
 */

public class DamageNegation extends Power {

	private static String xmlID = "DAMAGENEGATION";

	public DamageNegation(Element root) {
		super(root, DamageNegation.xmlID);
	}

	@Override
	public String getColumn2Output() {
		String ret = "";
		if (getName().trim().length() > 0) {
			ret = "<i>" + getName() + ":</i>  ";
		}
		if ((getInput() != null)
				&& (getInput().trim().length() > 0)
				&& ((getSelectedOption() == null) || (getSelectedOption()
						.getDisplay().indexOf("Mental") < 0))) {
			ret += getInput() + " ";
		}
		if (getSelectedOption() != null) {
			ret += getSelectedOption().getAlias();
		} else {
			ret += getAlias();
		}
		Adder physical = (Adder)findObjectByID(getAssignedAdders(), "PHYSICAL");
		physical.setDisplayInString(false);
		Adder energy = (Adder)findObjectByID(getAssignedAdders(), "ENERGY");
		energy.setDisplayInString(false);
		Adder mental = (Adder)findObjectByID(getAssignedAdders(), "MENTAL");
		mental.setDisplayInString(false);
		if (physical.getLevels()>0 || energy.getLevels()>0 || mental.getLevels()>0) {
			ret += " (";
			if (physical.getLevels()>0) {
				ret += "-"+physical.getLevels()+" DCs Physical";
			}
			if (energy.getLevels()>0) {
				if (physical.getLevels()>0) {
					ret += ", ";
				}
				ret += "-"+energy.getLevels()+" DCs Energy";
			}
			if (mental.getLevels()>0) {
				if (physical.getLevels()>0 || energy.getLevels() >0) {
					ret += ", ";
				}
				ret += "-"+mental.getLevels()+" DCs Mental";
			}
			ret += ")";
		}
		String adderString = getAdderString();
		if (adderString.trim().length() > 0) {
			ret += ", " + adderString;
		}
		ret += getModifierString();
		if ((getEndUsage() > 0)
				&& (GenericObject.findObjectByID(HeroDesigner.getActiveHero()
						.getPowers(), "ENDURANCERESERVE") != null)
				&& (GenericObject.findObjectByID(getAllAssignedModifiers(),
						"ENDRESERVEOREND") == null)
				&& !HeroDesigner.getInstance().getPrefs().useWG()) {
			if (getUseENDReserve()) {
				ret += " (uses END Reserve)";
			} else {
				ret += " (uses Personal END)";
			}
		}
		return ret;
	}

	@Override
	public String getDamageDisplay() {
		String ret = "-"+getLevels() + " DC"+(getLevels()>1?"s":"");
		return ret;
	}
}